## ros-humble-rosidl-generator-py 0.14.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rosidl_generator_py)

find_package(ament_cmake REQUIRED)

ament_export_dependencies(ament_cmake)
ament_export_dependencies(rmw)
ament_export_dependencies(rosidl_cmake)

ament_index_register_resource("rosidl_generator_packages")

ament_python_install_package(${PROJECT_NAME})

if(BUILD_TESTING)
  find_package(ament_cmake_pytest REQUIRED)

  find_package(rmw REQUIRED)
  find_package(rosidl_cmake REQUIRED)

  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  find_package(test_interface_files REQUIRED)

  find_package(python_cmake_module REQUIRED)
  find_package(PythonExtra MODULE REQUIRED)

  set(BUILDTYPE_PYTHON_EXECUTABLE "${PYTHON_EXECUTABLE}")
  if(WIN32 AND "${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
    set(BUILDTYPE_PYTHON_EXECUTABLE "${PYTHON_EXECUTABLE_DEBUG}")
  endif()

  include(cmake/register_py.cmake)
  include(cmake/rosidl_generator_py_get_typesupports.cmake)

  # Trick ament_target_dependencies() into thinking this package has been found
  set(rosidl_generator_py_FOUND "1")
  set(rosidl_generator_py_DIR "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

  # Need to call extras before get_typesupports, to register the extension
  rosidl_generator_py_extras(
    "${CMAKE_CURRENT_SOURCE_DIR}/bin/rosidl_generator_py"
    "${CMAKE_CURRENT_SOURCE_DIR}/rosidl_generator_py/__init__.py;${CMAKE_CURRENT_SOURCE_DIR}/rosidl_generator_py/generate_py_impl.py"
    "${CMAKE_CURRENT_SOURCE_DIR}/resource"
  )

  # If no message files were generated, skip the test.
  rosidl_generator_py_get_typesupports(_typesupport_impls)
  if(_typesupport_impls STREQUAL "")
    message(WARNING "No valid typesupport found for Python generator, skipping tests.")
  else()
    # Use a custom suffix for the target name here to detect regressions of this:
    #   https://github.com/ros2/rosidl_python/issues/11
    # The alternative style (just using ${PROJECT_NAME}) is used by most interface packages.
    rosidl_generate_interfaces(${PROJECT_NAME}_custom
      ${test_interface_files_MSG_FILES}
      # Cases not covered by test_interface_files
      msg/BuiltinTypeSequencesIdl.idl
      msg/StringArrays.msg
      msg/Property.msg
      ADD_LINTER_TESTS
      SKIP_INSTALL
    )

    set(_append_library_dirs "")
    if(WIN32)
      set(_append_library_dirs "${CMAKE_CURRENT_BINARY_DIR}/$<CONFIG>")
    endif()

    set(pythonpath "${CMAKE_CURRENT_BINARY_DIR}/rosidl_generator_py;${CMAKE_CURRENT_SOURCE_DIR}")
    if(NOT WIN32)
      string(REPLACE ";" ":" pythonpath "${pythonpath}")
    endif()
    ament_add_pytest_test(test_interfaces_py "test/test_interfaces.py"
      PYTHON_EXECUTABLE "${BUILDTYPE_PYTHON_EXECUTABLE}"
      APPEND_ENV "PYTHONPATH=${pythonpath}"
      APPEND_LIBRARY_DIRS "${_append_library_dirs}"
      WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/rosidl_generator_py"
    )

    ament_add_pytest_test(test_cli_extension test/test_cli_extension.py
      PYTHON_EXECUTABLE "${BUILDTYPE_PYTHON_EXECUTABLE}"
    )

    ament_add_pytest_test(test_property_py test/test_property.py
      PYTHON_EXECUTABLE "${BUILDTYPE_PYTHON_EXECUTABLE}"
      APPEND_ENV "PYTHONPATH=${pythonpath}"
      APPEND_LIBRARY_DIRS "${_append_library_dirs}"
      WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/rosidl_generator_py"
    )
  endif()
endif()

ament_package(
  CONFIG_EXTRAS "cmake/rosidl_generator_py_get_typesupports.cmake"
    "cmake/register_py.cmake"
    "rosidl_generator_py-extras.cmake.in"
)

install(
  PROGRAMS bin/rosidl_generator_py
  DESTINATION lib/rosidl_generator_py
)
install(
  DIRECTORY cmake resource
  DESTINATION share/${PROJECT_NAME}
)

=== debian/changelog ===
ros-humble-rosidl-generator-py (0.14.4-1bookworm) bookworm; urgency=high

  * Humble: Backport NaN fixes (#188 <https://github.com/ros2/rosidl_python/issues/188>)
  * Contributors: Chris Lalancette

 -- Michel Hidalgo <michel@ekumenlabs.com>  Mon, 07 Nov 2022 16:00:00 -0000

ros-humble-rosidl-generator-py (0.14.3-1bookworm) bookworm; urgency=high

  * Change decode error mode to replace (#176 <https://github.com/ros2/rosidl_python/issues/176>) (#179 <https://github.com/ros2/rosidl_python/issues/179>)
  * Fixing generated import order (backport #173 <https://github.com/ros2/rosidl_python/issues/173>) (#183 <https://github.com/ros2/rosidl_python/issues/183>)
  * Contributors: mergify[bot]

 -- Michel Hidalgo <michel@ekumenlabs.com>  Sun, 06 Nov 2022 16:00:00 -0000

ros-humble-rosidl-generator-py (0.14.2-1bookworm) bookworm; urgency=high

  * Removes erroneous unmatched closing parenthesis (#125 <https://github.com/ros2/rosidl_python/issues/125>)
  * require Python 3.6 as we use format strings in various places (#152 <https://github.com/ros2/rosidl_python/issues/152>)
  * Contributors: Charles Cross, William Woodall

 -- Michel Hidalgo <michel@ekumenlabs.com>  Mon, 28 Feb 2022 16:00:00 -0000

ros-humble-rosidl-generator-py (0.14.1-1bookworm) bookworm; urgency=high

  * Fix rosidl_generator_py assuming incorect library names (#149 <https://github.com/ros2/rosidl_python/issues/149>)
  * Fix for msg file containing a property field that is not at the end (#151 <https://github.com/ros2/rosidl_python/issues/151>)
  * Update package maintainers (#147 <https://github.com/ros2/rosidl_python/issues/147>)
  * Contributors: Chen Lihui, Michel Hidalgo, Shane Loretz

 -- Michel Hidalgo <michel@ekumenlabs.com>  Wed, 12 Jan 2022 16:00:00 -0000

ros-humble-rosidl-generator-py (0.14.0-1bookworm) bookworm; urgency=high

  * Use rosidl_get_typesupport_target() (#139 <https://github.com/ros2/rosidl_python/issues/139>)
  * Contributors: Shane Loretz

 -- Michel Hidalgo <michel@ekumenlabs.com>  Tue, 10 Aug 2021 16:00:00 -0000

ros-humble-rosidl-generator-py (0.13.0-1bookworm) bookworm; urgency=high

  * Support available typesupport specification in CLI extension (#133 <https://github.com/ros2/rosidl_python/issues/133>)
  * Use python_d for test_cli_extension in Debug mode (#136 <https://github.com/ros2/rosidl_python/issues/136>)
  * Add missing float/double bounds check (#128 <https://github.com/ros2/rosidl_python/issues/128>)
  * Contributors: Michel Hidalgo, Seulbae Kim, Shane Loretz

 -- Michel Hidalgo <michel@ekumenlabs.com>  Thu, 15 Jul 2021 16:00:00 -0000

ros-humble-rosidl-generator-py (0.12.0-1bookworm) bookworm; urgency=high

  * Added optimization for copying arrays using buffer protocol (#129 <https://github.com/ros2/rosidl_python/issues/129>)
  * Add smoke test for CLI extension (#132 <https://github.com/ros2/rosidl_python/issues/132>)
  * Install generated Python interfaces in a Python package (#131 <https://github.com/ros2/rosidl_python/issues/131>)
  * Contributors: Michel Hidalgo, ksuszka

 -- Michel Hidalgo <michel@ekumenlabs.com>  Thu, 10 Jun 2021 16:00:00 -0000

ros-humble-rosidl-generator-py (0.11.0-1bookworm) bookworm; urgency=high

  * Remove dependency from rosidl_typesupport_connext_c (#127 <https://github.com/ros2/rosidl_python/issues/127>)
  * Contributors: Andrea Sorbini

 -- Michel Hidalgo <michel@ekumenlabs.com>  Wed, 24 Mar 2021 16:00:00 -0000

ros-humble-rosidl-generator-py (0.10.0-1bookworm) bookworm; urgency=high

  * Expose Python code generation via rosidl generate CLI (#123 <https://github.com/ros2/rosidl_python/issues/123>)
  * remove maintainer (#126 <https://github.com/ros2/rosidl_python/issues/126>)
  * Contributors: Claire Wang, Michel Hidalgo

 -- Michel Hidalgo <michel@ekumenlabs.com>  Thu, 18 Mar 2021 16:00:00 -0000

ros-humble-rosidl-generator-py (0.9.4-1bookworm) bookworm; urgency=high

  * Update maintainers (#119 <https://github.com/ros2/rosidl_python/issues/119>)
  * Fix too early decref of WString when converting from Python to C (#117 <https://github.com/ros2/rosidl_python/issues/117>)
  * Add pytest.ini so tests succeed locally. (#116 <https://github.com/ros2/rosidl_python/issues/116>)
  * Contributors: Chris Lalancette, Claire Wang, Dirk Thomas

 -- Michel Hidalgo <michel@ekumenlabs.com>  Mon, 07 Dec 2020 16:00:00 -0000

ros-humble-rosidl-generator-py (0.9.3-1bookworm) bookworm; urgency=high

  * Add test_depend on rpyutils (#115 <https://github.com/ros2/rosidl_python/issues/115>)
  * Contributors: Jacob Perron

 -- Michel Hidalgo <michel@ekumenlabs.com>  Mon, 18 May 2020 16:00:00 -0000

ros-humble-rosidl-generator-py (0.9.2-1bookworm) bookworm; urgency=high

  * Explicitly add DLL directories for Windows before importing (#113 <https://github.com/ros2/rosidl_python/issues/113>)
  * Force extension points to be registered in order (#112 <https://github.com/ros2/rosidl_python/issues/112>)
  * Contributors: Ivan Santiago Paunovic, Jacob Perron

 -- Michel Hidalgo <michel@ekumenlabs.com>  Sun, 17 May 2020 16:00:00 -0000

ros-humble-rosidl-generator-py (0.9.1-1bookworm) bookworm; urgency=high

  * Add test dependency on rosidl_typesupport_c_packages (#110 <https://github.com/ros2/rosidl_python/issues/110>)
  * Contributors: Jacob Perron

 -- Michel Hidalgo <michel@ekumenlabs.com>  Tue, 28 Apr 2020 16:00:00 -0000

ros-humble-rosidl-generator-py (0.9.0-1bookworm) bookworm; urgency=high

  * Ensure the Python support target links against the C generator target (#108 <https://github.com/ros2/rosidl_python/issues/108>)
  * Skip inoperable typesupport implementations (#107 <https://github.com/ros2/rosidl_python/issues/107>)
  * Update includes to use non-entry point headers from detail subdirectory (#105 <https://github.com/ros2/rosidl_python/issues/105>)
  * Rename rosidl_generator_c namespace to rosidl_runtime_c (#103 <https://github.com/ros2/rosidl_python/issues/103>)


=== debian/control ===
Source: ros-humble-rosidl-generator-py
Section: misc
Priority: optional
Maintainer: Michel Hidalgo <michel@ekumenlabs.com>
Build-Depends: debhelper (>= 9.0.0), python3-numpy <!nocheck>, python3-pytest <!nocheck>, ros-humble-ament-cmake, ros-humble-ament-cmake-pytest <!nocheck>, ros-humble-ament-index-python <!nocheck>, ros-humble-ament-lint-auto <!nocheck>, ros-humble-ament-lint-common <!nocheck>, ros-humble-python-cmake-module <!nocheck>, ros-humble-rmw <!nocheck>, ros-humble-rosidl-cmake <!nocheck>, ros-humble-rosidl-generator-c <!nocheck>, ros-humble-rosidl-generator-cpp <!nocheck>, ros-humble-rosidl-parser <!nocheck>, ros-humble-rosidl-runtime-c, ros-humble-rosidl-typesupport-c <!nocheck>, ros-humble-rosidl-typesupport-fastrtps-c <!nocheck>, ros-humble-rosidl-typesupport-introspection-c <!nocheck>, ros-humble-rpyutils <!nocheck>, ros-humble-test-interface-files <!nocheck>, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-rosidl-generator-py
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3-numpy, ros-humble-ament-cmake, ros-humble-ament-index-python, ros-humble-python-cmake-module, ros-humble-rmw, ros-humble-rosidl-cli, ros-humble-rosidl-cmake, ros-humble-rosidl-generator-c, ros-humble-rosidl-parser, ros-humble-rosidl-runtime-c, ros-humble-rosidl-typesupport-c, ros-humble-rosidl-typesupport-interface, ros-humble-rpyutils, ros-humble-ros-workspace
Description: Generate the ROS interfaces in Python.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-rosidl-generator-py//opt/ros/humble/lib/:$(CURDIR)/debian/ros-humble-rosidl-generator-py//opt/ros/humble/opt/rosidl_generator_py/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install
